% Andrea Miglio 21/06/2017
% Emma Willett and Raphael Panayi 7/2017

% Script to generate .wav file from a frequencies which may change with
% time

%%
clear     % clear workspace
clf       % clear figure

totT=10; % total duration of time series / sound file
fs = 44100;        % standard sampling rate
Ts = 1/fs;         % sampling period
t = 0:Ts:totT;     % time vector

numax=100;      %muHz 

dim=1;
notes.degree=zeros(dim,1);
notes.freq=numax; % using numax as the frequency of the m=0 component

% define the rotational frequency as a linear function of time
rot_freq_min=0;
rot_freq_max=2;
rot_freq=linspace(rot_freq_min, rot_freq_max,numel(t));

i=0;
for m=-1:1:1
    i=i+1;
    for j=1:numel(t)        
        rot_splitting=rot_freq(j); % rotational splitting nu(|m|=1)-nu(m=0) assuming Ledoux factor =1
        notes.freqchange(i,j)=m*rot_splitting+numax;
    end
end

notes.amp=ones(size(notes.freqchange));

% Generate  first subplot
subplot(2,1,1)
scatter(t,notes.freqchange(1,:))
hold on
scatter(t,notes.freqchange(2,:))
scatter(t,notes.freqchange(3,:))
figure(gcf)

refnu=8000;         % Hz

numaxS=3090;            %Hz solar numax
convF=refnu/numaxS;     % factor to convert stellar osc. frequencies in audible range 

phase_flag=1;
intensity=create_starmusic_nuchange(notes, phase_flag, fs, totT, convF);

% Generate  second subplot
subplot(2,1,2)
scatter(t,intensity.collective)
figure(gcf)
%% generate sound

% Apply tapered cosine window
win = tukeywin(size(intensity.collective,2),0.1)';
intensity.collective = intensity.collective.*win;

% Write audio file
filename = ['test_splitting_freqmodulation.wav'];
audiowrite(filename,intensity.collective,fs,'BitsPerSample',16);

% Play sound
sound(intensity.collective,fs)